/*******************************************************************************
 *  Copyright 2017 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *  
 *    http://www.apache.org/licenses/LICENSE-2.0
 *  
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.hl7282.baselibs;

import cdac.medinfo.sdk.hl7282.baselibs.segmentfactory.DataElementFactory;
import cdac.medinfo.sdk.hl7282.commoninterface.IDataType;
import cdac.medinfo.sdk.hl7282.commoninterface.ISingleCollection;
import cdac.medinfo.sdk.hl7282.exceptions.InvalidComponentTypeException;
import cdac.medinfo.sdk.hl7282.utils.EnumDataType;
import cdac.medinfo.sdk.hl7282.utils.IDataTypeMap;

/**
 * VH - Visiting hours<p>
 * This data type contains the hours when a patient location is open for visiting.
 * <p>Represents an HL7 VH data type. 
 * This data type has the following attributes:</p><p>
 *  1. Start Day Range (ID)<b>Optional</b><br>
 *  2. End Day Range (ID)<b>Optional</b><br>
 *  3. Start Hour Range (TM)<b>Optional</b><br>
 *  4. End Hour Range (TM)<b>Optional</b><br><p>
 * This class provides accessors & mutators for the elements mentioned above.
 * This class override the equal method, to check whether some other object is "equal to" this one.
 * 
 * <p>User can also create Data Type through {@link DataElementFactory} 
 */
public class VH extends CompositeDataType   
{
	


	/**
	 * Default Constructor for VH
	 */
	public VH()
	{
		super(EnumDataType.HL7_DT_VH);
		 
	}

	/**
	 * Constructor  for VH class which takes four arguments and 
	 * sets the value in the respective member variable.
	 * @param iMinLength The Minimum length the DataType can have.
	 * @param iMaxLength The Maximum length the DataType can have.
	 * @param iCLength The Conformance length the DataType can have.
	 * @param iComponentType The Type of the component i.e Component or a subcomponent.
	 * @throws InvalidComponentTypeException - if Component Type is not specified or valid. 
	 */ 
	public VH(int iMinLength, int iMaxLength, String strCLength,int iComponentType) throws InvalidComponentTypeException
	{
		super(EnumDataType.HL7_DT_VH);
		this.iMinLength = iMinLength;
		this.iMaxLength = iMaxLength;
		this.iConformanceLength = strCLength;
		this.iComponentType = iComponentType;
		if(!isValidComponentType())
		{
			throw new InvalidComponentTypeException(this.getClass().getSimpleName());
		}
	}


	/**
	 * Constructor for VH class which takes five arguments and 
	 * sets the value in the respective member variable.
	 * @param iMinLength The Minimum length the DataType can have.
	 * @param iMaxLength The Maximum length the DataType can have.
	 * @param iCLength The Conformance length the DataType can have.
	 * @param iTableNo The Table number to which the value for the component is specified. 
	 * @param iComponentType The Type of the component i.e Component or a subcomponent.
	 * @throws InvalidComponentTypeException - if Component Type is not specified or valid. 
	 */
	public VH(int iMinLength, int iMaxLength, String strCLength,int iTableNo,int iComponentType) throws InvalidComponentTypeException
	{
		super(EnumDataType.HL7_DT_VH);
		this.iMinLength = iMinLength;
		this.iMaxLength = iMaxLength;
		this.iConformanceLength = strCLength;
		this.iTableNo = iTableNo;
		this.iComponentType = iComponentType;
		if(!isValidComponentType())
		{
			throw new InvalidComponentTypeException(this.getClass().getSimpleName());		
		}
	}
	/**
	 * Constructor for VH class which takes two arguments and 
	 * sets the value in the respective member variable.
	 * @param objIDataTypeMap object of Data Type Map.
	 * @param iComponentType The Type of the component i.e Component or a subcomponent.
	 * @throws InvalidComponentTypeException - if Component Type is not specified or valid. 
	 */
	public VH(int iComponentType,IDataTypeMap objIDataTypeMap)
	{
		super(EnumDataType.HL7_DT_VH);
		this.objIDataTypeMap = objIDataTypeMap;
		this.iComponentType = iComponentType;
		if(!isValidComponentType())
		{
			throw new InvalidComponentTypeException(this.getClass().getSimpleName());
		}
	}
	/**
	 * Constructor for VH class which takes five arguments and 
	 * sets the value in the respective member variable.
	 * @param objIDataTypeMap object of Data Type Map.
	 * @param iComponentType The Type of the component i.e Component or a subcomponent.
	 * @param iMinLength The Minimum length the DataType can have.
	 * @param iMaxLength The Maximum length the DataType can have.
	 * @param iCLength The Conformance length the DataType can have.
	 * @throws InvalidComponentTypeException - if Component Type is not specified or valid. 
	 */
	public VH(int iComponentType,int iMinLength, int iMaxLength, String strCLength,IDataTypeMap objIDataTypeMap)
	{
		super(EnumDataType.HL7_DT_VH);
		this.objIDataTypeMap = objIDataTypeMap;
		this.iComponentType = iComponentType;
		this.iMinLength = iMinLength;
		this.iMaxLength = iMaxLength;
		this.iConformanceLength = strCLength;

		if(!isValidComponentType())
		{
			throw new InvalidComponentTypeException(this.getClass().getSimpleName());
		}
	}
	/**
	 * Constructor for VH class which takes six arguments and 
	 * sets the value in the respective member variable.
	 * @param objIDataTypeMap object of Data Type Map.
	 * @param iComponentType The Type of the component i.e Component or a subcomponent.
	 * @param iMinLength The Minimum length the DataType can have.
	 * @param iMaxLength The Maximum length the DataType can have.
	 * @param iCLength The Conformance length the DataType can have.
	 * @param iTableNo The Table number to which the value for the component is specified. 
	 * @throws InvalidComponentTypeException - if Component Type is not specified or valid. 
	 */
	public VH(int iComponentType,int iMinLength, int iMaxLength, String strCLength,int ITableNo,IDataTypeMap objIDataTypeMap)
	{
		super(EnumDataType.HL7_DT_VH);
		this.objIDataTypeMap = objIDataTypeMap;
		this.iComponentType = iComponentType;
		this.iTableNo = ITableNo;
		this.iMinLength = iMinLength;
		this.iMaxLength = iMaxLength;
		this.iConformanceLength = strCLength;

		if(!isValidComponentType())
		{
			throw new InvalidComponentTypeException(this.getClass().getSimpleName());
		}
	}

	/**
	 *Sets the StartDayRange.
	 *@param strStartDayRange Starting day of visiting hours range.  
	 */
	public void setStartDayRange(String strStartDayRange)
	{
		if(strStartDayRange!=null)
			setComponentType(1, strStartDayRange);
		else
			setStartDayRange((ID)null);
	}


	/**
	 *Sets the StartDayRange.
	 *@param objID Starting day of visiting hours range. 
	 */
	public void setStartDayRange(ID objID)
	{
		setComponentType(1,objID);
	}

	/**
	 *Sets the EndDayRange.
	 *@param strEndDayRange Ending day of visiting hours range.  
	 */
	public void setEndDayRange(String strEndDayRange)
	{
		if(strEndDayRange!=null)
			setComponentType(2, strEndDayRange);
		else
			setEndDayRange((ID)null);
	}

	/**
	 *Sets the EndDayRange.
	 *@param objID Ending day of visiting hours range. 
	 */
	public void setEndDayRange(ID objID)
	{
		setComponentType(2,objID);
	}

	/**
	 *Sets the StartHourRange.
	 *@param strStartHourRange Starting hour on starting day of visiting hours range.  
	 */
	public void setStartHourRange(String strStartHourRange)
	{
		if(strStartHourRange!=null)
			setComponentType(3, strStartHourRange);
		else
			setStartHourRange((TM)null);
	}

	/**
	 *Sets the StartHourRange.
	 *@param objTM Starting hour on starting day of visiting hours range. 
	 */
	public void setStartHourRange(TM objTM)
	{
		setComponentType(3,objTM);
	}

	/**
	 *Sets the EndHourRange.
	 *@param strEndHourRange Ending hour on ending day of visiting hours range. 
	 */
	public void setEndHourRange(String strEndHourRange)
	{
		if(strEndHourRange!=null)
			setComponentType(4, strEndHourRange);
		else
			setEndHourRange((TM)null);
	}

	/**
	 *Sets the EndHourRange.
	 *@param objTM Ending hour on ending day of visiting hours range.
	 */
	public void setEndHourRange(TM objTM)
	{
		setComponentType(4,objTM);
	}

	/**
	 * Returns Start Day Range
	 * @return ID - data type.
	 */
	public ID getStartDayRange()
	{
		ISingleCollection<IDataType> objDataCollection =getComponentType(1);
		if(objDataCollection != null && objDataCollection.size() != 0) 
			return (ID)objDataCollection.elementAt(0);
		else
			return null;
	}

	/**
	 * Returns End Day Range
	 * @return ID - data type.
	 */
	public ID getEndDayRange()
	{
		ISingleCollection<IDataType> objDataCollection =getComponentType(2);
		if(objDataCollection != null && objDataCollection.size() != 0) 
			return (ID)objDataCollection.elementAt(0);
		else
			return null;
	}

	/**
	 * Returns Start Hour Range
	 * @return TM - data type.
	 */
	public TM getStartHourRange()
	{
		ISingleCollection<IDataType> objDataCollection =getComponentType(3);
		if(objDataCollection != null && objDataCollection.size() != 0) 
			return (TM)objDataCollection.elementAt(0);
		else
			return null;
	}

	/**
	 * Returns End Hour Range
	 * @return TM - data type.
	 */
	public TM getEndHourRange()
	{
		ISingleCollection<IDataType> objDataCollection =getComponentType(4);
		if(objDataCollection != null && objDataCollection.size() != 0) 
			return (TM)objDataCollection.elementAt(0);
		else
			return null;
	}

	/**
	 * This method checks the equality of Object.
	 * @param objObject object of Object class.
	 * @return boolean - shows success or failure of the comparison.
	 */
	public boolean equals(Object objObject)
	{
		if((objObject == null ) || (!(objObject instanceof VH)))
			return false;

		if(this.getStartDayRange() == null)
		{
			if(((VH)objObject).getStartDayRange() != null)
				return false;
		}
		else if(false == (this.getStartDayRange().equals(((VH)objObject).getStartDayRange())))
			return false;

		if(this.getEndDayRange() == null)
		{
			if(((VH)objObject).getEndDayRange() != null)
				return false;
		}
		else if(false == (this.getEndDayRange().equals(((VH)objObject).getEndDayRange())))
			return false;

		if(this.getStartHourRange() == null)
		{
			if(((VH)objObject).getStartHourRange() != null)
				return false;
		}
		else if(false == (this.getStartHourRange().equals(((VH)objObject).getStartHourRange())))
			return false;

		if(this.getEndHourRange() == null)
		{
			if(((VH)objObject).getEndHourRange() != null)
				return false;
		}
		else if(false == (this.getEndHourRange().equals(((VH)objObject).getEndHourRange())))
			return false;

		return true;
	}
}
